//
//  ViewController.m
//  圈圈动画尝试
//
//  Created by 陈高磊 on 2017/3/1.
//  Copyright © 2017年 yiyuan. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
{
    UIView *showView;
}
@property(nonatomic,strong)CAShapeLayer*tempLayer;
@property(nonatomic,strong)CAShapeLayer*tempLayer2;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
   
    // 创建一个view
    showView = [[UIView alloc] initWithFrame:CGRectMake(100, 100, 200, 200)];
    [self.view addSubview:showView];
    showView.backgroundColor = [UIColor redColor];
    showView.alpha = 0.5;
    UITapGestureRecognizer*tap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(touch:)];
    
    [showView addGestureRecognizer:tap];
    
  
    
    
    // 将layer添加进图层
//    [showView.layer addSublayer:self.layer];
//    [showView.layer addSublayer:self.layer2];
    

}
- (void)touch:(UITapGestureRecognizer*)tap{
    [self.tempLayer2 removeFromSuperlayer];
    [self.tempLayer removeFromSuperlayer];
    
    // 贝塞尔曲线(创建一个圆)
    UIBezierPath *path = [UIBezierPath bezierPathWithArcCenter:CGPointMake(200/2.f, 200/2.f) radius:100/2.f startAngle:0 endAngle:M_PI * 2 clockwise:YES];
    
    UIBezierPath *path2 = [UIBezierPath bezierPathWithArcCenter:CGPointMake(200/2.f, 200/2.f) radius:5.f startAngle:0 endAngle:M_PI * 2 clockwise:YES];
    
    
    // 创建一个shapeLayer1
    CAShapeLayer*layer = [CAShapeLayer layer];
    layer.frame         = showView.bounds;                // 与showView的frame一致
    layer.strokeColor   = [UIColor greenColor].CGColor;   // 边缘线的颜色
    layer.fillColor     = [UIColor clearColor].CGColor;   // 闭环填充的颜色
    layer.lineCap       = kCALineCapSquare;               // 边缘线的类型
    layer.path          = path.CGPath;                    // 从贝塞尔曲线获取到形状
    layer.lineWidth     = 2.0f;                           // 线条宽度
    layer.strokeStart   = 0.0f;
    layer.strokeEnd     = 1.0f;
    
    // 创建一个shapeLayer2
   CAShapeLayer* layer2 = [CAShapeLayer layer];
    layer2.frame         = showView.bounds;                // 与showView的frame一致
    layer2.strokeColor   = [UIColor greenColor].CGColor;   // 边缘线的颜色
    layer2.fillColor     = [UIColor clearColor].CGColor;   // 闭环填充的颜色
    layer2.lineCap       = kCALineCapSquare;               // 边缘线的类型
    layer2.path          = path2.CGPath;                    // 从贝塞尔曲线获取到形状
    layer2.lineWidth     = 2.0f;                           // 线条宽度
    layer2.strokeStart   = 0.0f;
    layer2.strokeEnd     = 1.0f;


    [showView.layer addSublayer:layer2];
  
    [showView.layer addSublayer:layer];
    
    
    CAKeyframeAnimation*alphaAnimation = [CAKeyframeAnimation animationWithKeyPath:@"opacity"];
    alphaAnimation.duration = 1.2;
    alphaAnimation.values = @[[NSNumber numberWithFloat:0.f],[NSNumber numberWithFloat:1.f],[NSNumber numberWithFloat:1.f],[NSNumber numberWithFloat:1.f],[NSNumber numberWithFloat:0.0f]];
    [layer addAnimation:alphaAnimation forKey:@"alpha"];

    CAKeyframeAnimation*alphaAnimation2 = [CAKeyframeAnimation animationWithKeyPath:@"opacity"];
    alphaAnimation2.duration = 1.5;
    alphaAnimation2.values = @[[NSNumber numberWithFloat:1.f],[NSNumber numberWithFloat:1.f],[NSNumber numberWithFloat:1.f],[NSNumber numberWithFloat:1.f],[NSNumber numberWithFloat:1.f],[NSNumber numberWithFloat:0.0f]];

    [layer2 addAnimation:alphaAnimation2 forKey:@"alpha"];
    // 给这个layer添加动画效果
     CAKeyframeAnimation *pathAnimation = [CAKeyframeAnimation animationWithKeyPath:@"transform.scale"];
    pathAnimation.duration = 1.2;
    pathAnimation.values = @[[NSNumber numberWithFloat:1.f],[NSNumber numberWithFloat:1.2f],[NSNumber numberWithFloat:1.0f],[NSNumber numberWithFloat:1.2f],[NSNumber numberWithFloat:1.0f]];
    
    [layer addAnimation:pathAnimation forKey:@"scale"];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [layer removeFromSuperlayer];
    });
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [layer2 removeFromSuperlayer];
    });
    self.tempLayer = layer;
    self.tempLayer2 = layer2;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
